import { api } from '@/utils/api'

export default class CurdApi {
  basePath

  api = api

  getList = (query) => api({
    url: `${this.basePath}/list`,
    method: 'POST',
    data: query
  })

  getPagination = (query, pagination) => api({
    url: `${this.basePath}/page`,
    method: 'POST',
    data: Object.assign({}, query, pagination)
  })

  getDetail = (data, Target) => api({
    url: `${this.basePath}/${data[Target.$$idProp]}`,
    method: 'GET'
  })

  save = (data, saveType, Target) => api({
    url: `${this.basePath}`,
    method: saveType,
    data
  })

  delete = (data, Target) => api({
    url: `${this.basePath}/${data[Target.$$idProp]}`,
    method: 'DELETE'
  })

  constructor (basePath) {
    this.basePath = basePath
  }
}
